package cz.muni.fi.pb162.cviceni;


/**
 * Rozhrani Edge reprezentuje hranu grafu
 * @author Zuzana Neverilova
 * @version 2. 12. 2005
 */

public interface Edge
{
    /**
     * Vraci delku hrany
     * @return delka hrany
     */    
   int getLength();
     /**
     * Vraci uzel, ze ktereho hrana vychazi.
     * @return uzel, ze ktereho hrana vychazi
     */
   Node getFrom();
    /**
     * Vraci uzel, do ktereho hrana smeruje.
     * @return uzel, do ktereho hrana smeruje
     */   
   Node getTo();
    /**
     * Rovnost hran. Hrany jsou stejne, pokud jsou hrany a maji
     * stejne oba uzly.
     */
   boolean equals(Object o);
    /**
     * Hashcode hrany neni specifikovany. Orientovana hrana to bude mit jinak nez neorientovana.
     * U neorientovane by melo platit: hrana z A do B ma stejny hashCode jako hrana z B do A.
     */
    int hashCode();

    /**
     * Porovnavani hran. Pokud maji hrany stejnou delku, porovnava se podle
     * jmen uzlu.
     * @param o objekt k porovnani
     * @return porovnani hran
     */
    int compareTo(Object o);

    /**
     * Textova reprezentace hrany
     * @return textova reprezentace hrany
     */
    String toString();
    
    
}
